package ejb31.war.servlet;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptors;
import javax.interceptor.InvocationContext;
import javax.ejb.Stateless;
import javax.annotation.Resource;
import javax.ejb.EJB;

@Stateless
@Interceptors(ProfilingInterceptor.class)
public class HelloBean implements HelloLocal {

    @EJB MessageBean msg;
    String MESSAGE = "HelloBean";
    String MESSAGE2 = "checkPermission";

    @Resource
    private javax.ejb.SessionContext ctx;

    public String sayHello() {
        String hello = new String ("Hello from a interceptor-enabled bean!");
        if (msg != null && !msg.getMessage().contains(MESSAGE)){
	    msg.appendMessage(MESSAGE);
	}
	return hello;
    }

    @AroundInvoke
    // mark this method as a bean interceptor
    public Object checkPermission(InvocationContext ic) throws Exception {
        System.out.println("*** Demo checkPermission interceptor invoked *** ");
        System.out.println("*** ctx ="+ ctx);
        if (msg != null && !msg.getMessage().contains(MESSAGE2)){
	    msg.appendMessage(MESSAGE2);
	}        
        // you can implement your own security framework using interceptors
        /*
        if (!ctx.getCallerPrincipal().getName().equals("oc4jadmin")) {
            throw new SecurityException("Caller: '"
                    + ctx.getCallerPrincipal().getName()
                    + "' does not have permissions for method "
                    + ic.getMethod());
        }
	*/
        return ic.proceed();
    }

}
