package ejb31.war.servlet;

import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;
import javax.ejb.EJB;

public class ProfilingInterceptor {

    @EJB MessageBean msg;
    String MESSAGE = "ProfilingInterceptor";

    @AroundInvoke
    public Object profile(InvocationContext ctx) throws Exception {
        System.out.println("*** Demo Profile Interceptor invoked ***");

        System.out.println("profile: msg="+msg);
        if (msg != null && !msg.getMessage().contains(MESSAGE)){
	    msg.appendMessage(MESSAGE);
	}

        long startTime = 0;
        long endTime = 0;
        try {
            startTime = System.currentTimeMillis();
            return ctx.proceed();
        } finally {
            endTime = System.currentTimeMillis();
            System.out.println("*** Method " + ctx.getMethod()
                    + " executed in " + (endTime - startTime) + "ms ***");
        }

    }
}

