package ejb31.war.servlet;

import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.ejb.EJB;
import javax.sql.DataSource;
import javax.transaction.UserTransaction;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class TestServlet extends HttpServlet {
   
    @EJB
    private HelloLocal hello;

    @EJB 
    private MessageBean msg;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        boolean status = false;
        String result = "";
        String EXPECTED_RESULT1 ="Hello from a interceptor-enabled bean!";
	String EXPECTED_RESULT2 ="ProfilingInterceptorcheckPermissionHelloBean";

        try {
            
            out.println("-------TestServlet--------");  
            out.println("TestServlet at " + request.getContextPath ());

            String testcase = request.getParameter("tc");
            out.println("testcase = " + testcase);
            if (testcase != null) {

	      if ("invoke".equals(testcase)){
		out.println("HelloBean:");
		out.println("@EJB Injection="+hello);
		if (hello != null){
		  result = hello.sayHello();
 		  out.println("result: "+result);
		  if (result.equals(EXPECTED_RESULT1))
		    status = true;
		}
	      } if ("verify".equals(testcase)){
                result = msg.getMessage();
		out.println("result: "+result);
                if (result.equals(EXPECTED_RESULT2))
		  status = true;
	      }
	  }
        } catch (Exception ex ) {
            ex.printStackTrace();
            System.out.println("servlet test failed");
            throw new ServletException(ex);
        } finally { 
            if (status) 
	      out.println("Test:Pass");
            else
	      out.println("Test:Fail");
            out.close();
        }
    } 

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 


    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    public String getServletInfo() {
        return "AnnontatedServlet";
    }

    private Object lookupField(String name) {
        try {
            return new InitialContext().lookup("java:comp/env/" + getClass().getName() + "/" + name);
        } catch (NamingException e) {
            return null;
        }
    }

}



